#ifndef _DECL_RandRefLB_H_
#define _DECL_RandRefLB_H_
#include "charm++.h"
#include "CentralLB.decl.h"

/* DECLS: group RandRefLB: CentralLB{
void RandRefLB(void);
};
 */
class RandRefLB;
class CProxy_RandRefLB:  public virtual _CK_GID, public CProxy_CentralLB{
  public:
    static int __idx;
    static void __register(const char *s, size_t size);
    CProxy_RandRefLB(CkGroupID _gid) :CProxy_CentralLB(_gid){ _ck_gid = _gid; _setChare(0); }
    CProxy_RandRefLB(CkChareID __cid) :CProxy_CentralLB(__cid){ ckSetChareId(__cid); }
    CkChareID ckGetChareId(void) { return _ck_cid; }
    void ckSetChareId(CkChareID __cid){_CHECK_CID(__cid,__idx);_ck_cid=__cid;_setChare(1);}
    CkGroupID ckGetGroupId(void) { return _ck_gid; }
    void ckSetGroupId(CkGroupID _gid){_ck_gid=_gid;_setChare(0);}
    RandRefLB* ckLocalBranch(void) {
      return (RandRefLB *) CkLocalBranch(_ck_gid);
    }
    static RandRefLB* ckLocalBranch(CkGroupID gID) {
      return (RandRefLB *) CkLocalBranch(gID);
    }
/* DECLS: void RandRefLB(void);
 */
    static CkGroupID ckNew(void);
    static CkGroupID ckNewSync(void);
    CProxy_RandRefLB(int retEP, CkChareID *cid);
    CProxy_RandRefLB(void);
    static int  __idx_RandRefLB_void;
    static int  ckIdx_RandRefLB(void) { return __idx_RandRefLB_void; }
    static void _call_RandRefLB_void(void* msg, RandRefLB* obj);
};

extern void _registerRandRefLB(void);
#endif
